diff --git a/yum/repos.py b/yum/repos.py
index 3793bad..d5e50ac 100644
--- a/yum/repos.py
+++ b/yum/repos.py
@@ -15,13 +15,14 @@
 # Copyright 2004 Duke University 
 
 import re
-import fnmatch
 import types
 import logging
 import misc
+import os
 
 import Errors
 from packageSack import MetaSack
+import urlgrabber.grabber
 
 from weakref import proxy as weakref
 
@@ -29,7 +30,7 @@ class _wrap_ayum_getKeyForRepo:
     """ This is a wrapper for calling YumBase.getKeyForRepo() because
         otherwise we take a real reference through the bound method and
         that is d00m (this applies to YumBase and RepoStorage, hence why
-        we have a seperate class).
+        we have a separate class).
         A "better" fix might be to explicitly pass the YumBase instance to
         the callback ... API change! """
     def __init__(self, ayum, ca=False):
@@ -67,8 +68,57 @@ class RepoStorage:
         self._cache_enabled_repos = []
         self.quick_enable_disable = {}
 
+        #  This allows plugins to setup a repo. just before the first
+        # listEnabled() call.
+        self._list_enabled_hasrun = False
+
+    def retrieveAllMD(self):
+        """ Download metadata for all enabled repositories,
+            based on mdpolicy.
+        """
+
+        if not hasattr(urlgrabber.grabber, 'parallel_wait'):
+            return
+
+        repos = []
+        for repo in self.listEnabled():
+            if repo.cache:
+                continue
+            try:
+                dl = repo._async and repo._commonLoadRepoXML(repo)
+            except Errors.RepoError, e:
+                if not repo.skip_if_unavailable:
+                    raise
+                self.disableRepo(repo.id)
+                dl = False
+            if dl:
+                mdtypes = repo._mdpolicy2mdtypes()
+                downloading = repo._commonRetrieveDataMD_list(mdtypes)
+                repos.append((repo, downloading, [False]))
+
+        # with sizes first, then without sizes..
+        for no_size in (False, True):
+            for repo, downloading, error in repos:
+                def failfunc(obj, error=error):
+                    error[0] = True
+                for (ndata, nmdtype) in downloading:
+                    if (ndata.size is None) == no_size:
+                        repo._retrieveMD(nmdtype, async=True, failfunc=failfunc)
+            urlgrabber.grabber.parallel_wait()
+
+        # done or revert
+        for repo, downloading, error in repos:
+            if error[0]: # some MD failed?
+                repo._revertOldRepoXML()
+            else:
+                repo._commonRetrieveDataMD_done(downloading)
+
     def doSetup(self, thisrepo = None):
         
+        if thisrepo is None:
+            # Just in case the prelistenabledrepos plugin point hasn't run.
+            self.listEnabled()
+
         self.ayum.plugins.run('prereposetup')
         
         if thisrepo is None:
@@ -79,6 +129,17 @@ class RepoStorage:
         if len(repos) < 1:
             self.logger.debug('No Repositories Available to Set Up')
 
+        if hasattr(urlgrabber.grabber, 'pycurl'):
+            # Must do basename checking, on cert. files...
+            cert_basenames = {}
+            for repo in self.listEnabled():
+                if repo.sslclientcert:
+                    bn = os.path.basename(repo.sslclientcert)
+                    other = cert_basenames.setdefault(bn, repo)
+                    if repo.sslclientcert != other.sslclientcert:
+                        msg = 'sslclientcert basename shared between %s and %s'
+                        raise Errors.ConfigError, msg % (repo, other)
+
         for repo in repos:
             repo.setup(self.ayum.conf.cache, self.ayum.mediagrabber,
                    gpg_import_func = self.gpg_import_func, confirm_func=self.confirm_func,
@@ -87,8 +148,13 @@ class RepoStorage:
             # so nothing else touches us
             if not repo.enabled:
                 self.disableRepo(repo.id)
+            else:
+                pkgdir = getattr(self.ayum.conf, 'downloaddir', None)
+                if pkgdir:
+                    repo.pkgdir = pkgdir
                 
         self._setup = True
+        self.retrieveAllMD()
         self.ayum.plugins.run('postreposetup')
         
     def __str__(self):
@@ -135,17 +201,25 @@ class RepoStorage:
             raise Errors.RepoError, \
                 'Error getting repository data for %s, repository not found' % (repoid)
 
-    def findRepos(self,pattern):
-        """find all repositories matching fnmatch `pattern`"""
+    def findRepos(self, pattern, name_match=False, ignore_case=False):
+        """ Find all repositories matching fnmatch `pattern` on the repo.id,
+            can also do case insensitive searches and/or search on the name."""
+
+        if pattern in self.repos: # Minor opt. as we do this a lot...
+            return [self.repos[pattern]]
 
         result = []
         
         for item in pattern.split(','):
             item = item.strip()
-            match = re.compile(fnmatch.translate(item)).match
+            match = misc.compile_pattern(item.strip(), ignore_case)
             for name,repo in self.repos.items():
-                if match(name):
+                assert name == repo.id
+                if match(name) or match(repo.ui_id):
+                    result.append(repo)
+                elif name_match and match(repo.name):
                     result.append(repo)
+
         return result
         
     def disableRepo(self, repoid):
@@ -187,6 +261,10 @@ class RepoStorage:
     def listEnabled(self):
         """return list of enabled repo objects"""
 
+        if not self._list_enabled_hasrun:
+            self.ayum.plugins.run('prelistenabledrepos')
+            self._list_enabled_hasrun = True
+
         if (self._cache_enabled_repos is not None and
             not self.quick_enable_disable):
             return self._cache_enabled_repos
@@ -223,15 +301,16 @@ class RepoStorage:
         
         self._cachedir = cachedir
         for repo in self.repos.values():
-            repo.old_base_cache_dir = repo.basecachedir
-            repo.basecachedir = cachedir
+            if cachedir != repo.basecachedir:
+                repo.old_base_cache_dir = repo.basecachedir
+                repo.basecachedir = cachedir
 
 
-    def setProgressBar(self, obj):
+    def setProgressBar(self, obj, multi_obj=None):
         """sets the progress bar for downloading files from repos"""
         
         for repo in self.repos.values():
-            repo.setCallback(obj)
+            repo.setCallback(obj, multi_obj)
 
     def setFailureCallback(self, obj):
         """sets the failure callback for all repos"""
@@ -288,6 +367,16 @@ class RepoStorage:
         else:
             data = [ mdtype ]
          
+        if hasattr(urlgrabber.grabber, 'parallel_wait'):
+            # download all metadata in parallel
+            for repo in myrepos:
+                if repo.cache:
+                    continue
+                if repo._async:
+                    sack = repo.getPackageSack()
+                    sack._retrieve_async(repo, data)
+            urlgrabber.grabber.parallel_wait()
+
         for repo in myrepos:
             sack = repo.getPackageSack()
             try:
@@ -329,6 +418,11 @@ class Repository:
     def __del__(self):
         self.close()
 
+    def _ui_id(self):
+        """ Show self.id, so we can use it and override it. """
+        return self.id
+    ui_id = property(_ui_id)
+
     def close(self):
         pass
 
diff --git a/yum/rpmsack.py b/yum/rpmsack.py
index e289a7a..138e53f 100644
--- a/yum/rpmsack.py
+++ b/yum/rpmsack.py
@@ -48,6 +48,17 @@ def _open_no_umask(*args):
 
     return ret
 
+def _makedirs_no_umask(*args):
+    """ Annoying people like to set umask's for root, which screws everything
+        up for user readable stuff. """
+    oumask = os.umask(022)
+    try:
+        ret = os.makedirs(*args)
+    finally:
+        os.umask(oumask)
+
+    return ret
+
 def _iopen(*args):
     """ IOError wrapper BS for open, stupid exceptions. """
     try:
@@ -119,7 +130,7 @@ class RPMInstalledPackage(YumInstalledPackage):
 
     def required_packages(self):
         pkgset = set()
-        for (reqn, reqf, reqevr) in self.requires:
+        for (reqn, reqf, reqevr) in self.strong_requires:
             for pkg in self.rpmdb.getProvides(reqn, reqf, reqevr):
                 if pkg != self:
                     pkgset.add(pkg)
@@ -222,6 +233,11 @@ class RPMDBPackageSack(PackageSackBase):
             self._persistdir = root +  '/' + persistdir
         else:
             self._persistdir = persistdir
+        if hasattr(rpm, 'expandMacro'):
+            dbpath = rpm.expandMacro('%_dbpath')
+        else:
+            dbpath = '/var/lib/rpm'
+        self._rpmdbpath = os.path.normpath(root + '/' + dbpath)
         self._have_cached_rpmdbv_data = None
         self._cached_conflicts_data = None
         # Store the result of what happens, if a transaction completes.
@@ -325,7 +341,7 @@ class RPMDBPackageSack(PackageSackBase):
 
         #  We are keeping some data from before, and sometimes (Eg. remove only)
         # we never open the rpmdb again ... so get the mtime now.
-        rpmdbfname  = self.root + "/var/lib/rpm/Packages"
+        rpmdbfname  = self._rpmdbpath + "/Packages"
         self._cached_rpmdb_mtime = os.path.getmtime(rpmdbfname)
 
         def _safe_del(x, y):
@@ -364,7 +380,8 @@ class RPMDBPackageSack(PackageSackBase):
             pkg = self.searchNevra(n, e, v, r, a)
             if not pkg:
                 # Wibble?
-                self._deal_with_bad_rpmdbcache("dCDPT(pkg checksums)")
+                self._deal_with_bad_rpmdbcache("dCDPT(pkg checksums): %s" %
+                                               txmbr)
                 continue
 
             pkg = pkg[0]
@@ -387,7 +404,7 @@ class RPMDBPackageSack(PackageSackBase):
         else:
             self._cachedir = '/' + cachedir
 
-        if hasattr(self, 'yumdb'): # Need to keep this upto date, after init.
+        if hasattr(self, 'yumdb'): # Need to keep this up to date, after init.
             version_path = os.path.normpath(self._cachedir + '/version')
             self.yumdb.conf.version_path = version_path
 
@@ -534,13 +551,11 @@ class RPMDBPackageSack(PackageSackBase):
             qpat = pat[0]
             if qpat in ('?', '*', '['):
                 qpat = None
-            if ignore_case:
-                if qpat is not None:
-                    qpat = qpat.lower()
-                ret.append((qpat, re.compile(fnmatch.translate(pat), re.I)))
-            else:
-                ret.append((qpat, re.compile(fnmatch.translate(pat))))
+            elif ignore_case:
+                qpat = qpat.lower()
+            ret.append((qpat, misc.compile_pattern(pat, ignore_case)))
         return ret
+
     @staticmethod
     def _match_repattern(repatterns, hdr, ignore_case):
         """ This is basically parsePackages() but for rpm hdr objects. """
@@ -558,20 +573,20 @@ class RPMDBPackageSack(PackageSackBase):
                 qname = qname.lower()
             if qpat is not None and qpat != qname and qpat != epoch[0]:
                 continue
-            if repat.match(hdr['name']):
+            if repat(hdr['name']):
                 return True
-            if repat.match("%(name)s-%(version)s-%(release)s.%(arch)s" % hdr):
+            if repat("%(name)s-%(version)s-%(release)s.%(arch)s" % hdr):
                 return True
-            if repat.match("%(name)s.%(arch)s" % hdr):
+            if repat("%(name)s.%(arch)s" % hdr):
                 return True
-            if repat.match("%(name)s-%(version)s" % hdr):
+            if repat("%(name)s-%(version)s" % hdr):
                 return True
-            if repat.match("%(name)s-%(version)s-%(release)s" % hdr):
+            if repat("%(name)s-%(version)s-%(release)s" % hdr):
                 return True
-            if repat.match(epoch + ":%(name)s-%(version)s-%(release)s.%(arch)s"
+            if repat(epoch + ":%(name)s-%(version)s-%(release)s.%(arch)s"
                            % hdr):
                 return True
-            if repat.match("%(name)s-%(epoch)s:%(version)s-%(release)s.%(arch)s"
+            if repat(("%(name)s-" + epoch + ":%(version)s-%(release)s.%(arch)s")
                            % hdr):
                 return True
         return False
@@ -592,7 +607,23 @@ class RPMDBPackageSack(PackageSackBase):
                 # will pick up any loads :)
                 pkgs = self.searchNames([pat])
                 if not pkgs:
-                    break
+                    # We need to do a big search for 'pkg*'
+                    if misc.re_glob(pat):
+                        break
+                    # We need to do a big search for 'pkg-1.2'
+                    if '-' in pat:
+                        break
+                    # We need to do a big search for 'pkg.noarch'
+                    if '.' in pat:
+                        break
+                    #  We don't need to do a big search for '0:pkg', because
+                    # <en> isn't possible ... and envra matches the above.
+                    # if ':' in pat:
+                    #    break
+
+                    #  At this point we have just found something that doesn't
+                    # match, like "yum list zzuf" ... we don't want this to take
+                    # the much slower path.
                 ret.extend(pkgs)
             else:
                 return ret
@@ -616,7 +647,7 @@ class RPMDBPackageSack(PackageSackBase):
             for hdr, idx in self._get_packages():
                 if self._match_repattern(rpats, hdr, ignore_case):
                     self._makePackageObject(hdr, idx)
-            self._completely_loaded = patterns is None
+            self._completely_loaded = rpats is None
 
         pkgobjlist = self._idx2pkg.values()
         # Remove gpg-pubkeys, as no sane callers expects/likes them...
@@ -680,11 +711,56 @@ class RPMDBPackageSack(PackageSackBase):
         rpmdbv = self.simpleVersion(main_only=True)[0]
         self._write_conflicts_new(pkgs, rpmdbv)
 
+    def _uncached_returnObsoletePackages(self):
+        """ Load the packages which have obsoletes from the rpmdb, this is
+            needed because newer rpm's have obsoletes imply conflicts. """
+
+        if self._cached_obsoletes_data is None:
+            result = {}
+
+            for hdr, idx in self._get_packages('obsoletename'):
+                if not hdr[rpm.RPMTAG_OBSOLETENAME]:
+                    # Pre. rpm-4.9.x the above dbMatch() does nothing.
+                    continue
+
+                po = self._makePackageObject(hdr, idx)
+                result[po.pkgid] = po
+                if po._has_hdr:
+                    continue # Unlikely, but, meh...
+
+                po.hdr = hdr
+                po._has_hdr = True
+                po.obsoletes
+                po._has_hdr = False
+                del po.hdr
+            self._cached_obsoletes_data = result.values()
+
+        return self._cached_obsoletes_data
+
+    def _write_obsoletes_new(self, pkgs, rpmdbv):
+        if not os.access(self._cachedir, os.W_OK):
+            return
+
+        obsoletes_fname = self._cachedir + '/obsoletes'
+        fo = _open_no_umask(obsoletes_fname + '.tmp', 'w')
+        fo.write("%s\n" % rpmdbv)
+        fo.write("%u\n" % len(pkgs))
+        for pkg in sorted(pkgs):
+            for var in pkg.pkgtup:
+                fo.write("%s\n" % var)
+        fo.close()
+        os.rename(obsoletes_fname + '.tmp', obsoletes_fname)
+
+    def _write_obsoletes(self, pkgs):
+        rpmdbv = self.simpleVersion(main_only=True)[0]
+        self._write_obsoletes_new(pkgs, rpmdbv)
+
     def _deal_with_bad_rpmdbcache(self, caller):
         """ This shouldn't be called, but people are hitting weird stuff so
             we want to deal with it so it doesn't stay broken "forever". """
         misc.unlink_f(self._cachedir + "/version")
         misc.unlink_f(self._cachedir + '/conflicts')
+        misc.unlink_f(self._cachedir + '/obsoletes')
         misc.unlink_f(self._cachedir + '/file-requires')
         misc.unlink_f(self._cachedir + '/pkgtups-checksums')
         #  We have a couple of options here, we can:
@@ -701,15 +777,15 @@ class RPMDBPackageSack(PackageSackBase):
         if __debug__:
             raise Errors.PackageSackError, 'Rpmdb checksum is invalid: %s' % caller
 
-    def _read_conflicts(self):
+    def _read_pkglist(self, fname):
         if not self.__cache_rpmdb__:
             return None
 
         def _read_str(fo):
             return fo.readline()[:-1]
 
-        conflict_fname = self._cachedir + '/conflicts'
-        fo, e = _iopen(conflict_fname)
+        full_fname = self._cachedir + '/' + fname
+        fo, e = _iopen(full_fname)
         if fo is None:
             return None
         frpmdbv = fo.readline()
@@ -719,7 +795,7 @@ class RPMDBPackageSack(PackageSackBase):
 
         ret = []
         try:
-            # Read the conflicts...
+            # Read the pkgs...
             pkgtups_num = int(_read_str(fo))
             while pkgtups_num > 0:
                 pkgtups_num -= 1
@@ -732,10 +808,13 @@ class RPMDBPackageSack(PackageSackBase):
             if fo.readline() != '': # Should be EOF
                 return None
         except ValueError:
-            self._deal_with_bad_rpmdbcache("conflicts")
+            self._deal_with_bad_rpmdbcache(fname)
             return None
 
-        self._cached_conflicts_data = ret
+        return ret
+
+    def _read_conflicts(self):
+        self._cached_conflicts_data = self._read_pkglist("conflicts")
         return self._cached_conflicts_data
 
     def transactionCacheConflictPackages(self, pkgs):
@@ -752,6 +831,24 @@ class RPMDBPackageSack(PackageSackBase):
 
         return pkgs
 
+    def transactionCacheObsoletePackages(self, pkgs):
+        if self.__cache_rpmdb__:
+            self._trans_cache_store['obsoletes'] = pkgs
+
+    def _read_obsoletes(self):
+        self._cached_obsoletes_data = self._read_pkglist("obsoletes")
+        return self._cached_obsoletes_data
+
+    def returnObsoletePackages(self):
+        """ Return a list of packages that have obsoletes. """
+        pkgs = self._read_obsoletes()
+        if pkgs is None:
+            pkgs = self._uncached_returnObsoletePackages()
+            if self.__cache_rpmdb__:
+                self._write_obsoletes(pkgs)
+
+        return pkgs
+
     def transactionResultVersion(self, rpmdbv):
         """ We are going to do a transaction, and the parameter will be the
             rpmdb version when we finish. The idea being we can update all
@@ -765,6 +862,10 @@ class RPMDBPackageSack(PackageSackBase):
             pkgs = self._trans_cache_store['conflicts']
             self._write_conflicts_new(pkgs, rpmdbv)
 
+        if 'obsoletes' in self._trans_cache_store:
+            pkgs = self._trans_cache_store['obsoletes']
+            self._write_obsoletes_new(pkgs, rpmdbv)
+
         if 'file-requires' in self._trans_cache_store:
             data = self._trans_cache_store['file-requires']
             self._write_file_requires(rpmdbv, data)
@@ -993,7 +1094,7 @@ class RPMDBPackageSack(PackageSackBase):
             return
 
         if not load_packages:
-             return checksum_data
+            return checksum_data
 
         for pkgtup in checksum_data:
             if checksum_data[pkgtup] is None:
@@ -1002,7 +1103,8 @@ class RPMDBPackageSack(PackageSackBase):
             (n, a, e, v, r) = pkgtup
             pkg = self.searchNevra(n, e, v, r, a)
             if not pkg:
-                self._deal_with_bad_rpmdbcache("pkg checksums")
+                self._deal_with_bad_rpmdbcache("pkg checksums: %s-%s:%s-%s.%s" %
+                                               (n, e, v, r, a))
                 continue
             pkg = pkg[0]
             (T, D) = checksum_data[pkgtup]
@@ -1049,7 +1151,7 @@ class RPMDBPackageSack(PackageSackBase):
         # http://lists.rpm.org/pipermail/rpm-maint/2007-November/001719.html
         # ...if anything gets implemented, we should change.
         rpmdbvfname = self._cachedir + "/version"
-        rpmdbfname  = self.root + "/var/lib/rpm/Packages"
+        rpmdbfname  = self._rpmdbpath + "/Packages"
 
         if os.path.exists(rpmdbvfname) and os.path.exists(rpmdbfname):
             # See if rpmdb has "changed" ...
@@ -1072,7 +1174,7 @@ class RPMDBPackageSack(PackageSackBase):
         if self._cached_rpmdb_mtime is None:
             return # We haven't loaded any packages!!!
 
-        rpmdbfname  = self.root + "/var/lib/rpm/Packages"
+        rpmdbfname  = self._rpmdbpath + "/Packages"
         if not os.path.exists(rpmdbfname):
             return # haha
 
@@ -1088,7 +1190,7 @@ class RPMDBPackageSack(PackageSackBase):
                 return
 
             try:
-                os.makedirs(self._cachedir)
+                _makedirs_no_umask(self._cachedir)
             except (IOError, OSError), e:
                 return
 
@@ -1223,7 +1325,7 @@ class RPMDBPackageSack(PackageSackBase):
                 if not pkgs:
                     self._pkgname_fails.add(name)
             else:
-                pkgs = self.returnPkgs()
+                pkgs = self.returnPackages()
             for po in pkgs:
                 for tag in ('arch', 'rel', 'ver', 'epoch'):
                     if loc[tag] is not None and loc[tag] != getattr(po, tag):
@@ -1268,7 +1370,7 @@ class RPMDBPackageSack(PackageSackBase):
         self._name2pkg.setdefault(po.name, []).append(po)
         self._tup2pkg[po.pkgtup] = po
         if self.__cache_rpmdb__ and self._cached_rpmdb_mtime is None:
-            rpmdbfname  = self.root + "/var/lib/rpm/Packages"
+            rpmdbfname  = self._rpmdbpath + "/Packages"
             self._cached_rpmdb_mtime = os.path.getmtime(rpmdbfname)
 
         return po
@@ -1456,7 +1558,7 @@ class RPMDBPackageSack(PackageSackBase):
         providers = set() # Speedup, as usual :)
         problems = []
         for pkg in sorted(pkgs): # The sort here is mainly for "UI"
-            for rreq in pkg.requires:
+            for rreq in pkg.strong_requires:
                 if rreq[0].startswith('rpmlib'): continue
                 if rreq in providers:            continue
 
@@ -1481,6 +1583,8 @@ class RPMDBPackageSack(PackageSackBase):
                 prob = RPMDBProblemDependency(pkg, "conflicts", found=found,
                                               conflicts=res)
                 problems.append(prob)
+
+            # Note that obsoletes are checked separately, and are name only.
         return problems
 
     def _iter_two_pkgs(self, ignore_provides):
@@ -1562,11 +1666,11 @@ class RPMDBAdditionalData(object):
         self._packages = {} # pkgid = dir
         if not os.path.exists(self.conf.db_path):
             try:
-                os.makedirs(self.conf.db_path)
+                _makedirs_no_umask(self.conf.db_path)
+                self.conf.writable = True
             except (IOError, OSError), e:
                 # some sort of useful thing here? A warning?
-                return
-            self.conf.writable = True
+                pass
         else:
             if os.access(self.conf.db_path, os.W_OK):
                 self.conf.writable = True
@@ -1622,6 +1726,7 @@ class RPMDBAdditionalDataPackage(object):
                                 'installed_by', 'changed_by',
                                 'from_repo', 'from_repo_revision',
                                 'from_repo_timestamp', 'releasever',
+                                'group_member',
                                 'command_line'])
 
     def __init__(self, conf, pkgdir, yumdb_cache=None):
@@ -1706,9 +1811,11 @@ class RPMDBAdditionalDataPackage(object):
         return os.path.normpath(self._mydir + '/' + attr)
 
     def _write(self, attr, value):
+        value = str(value)
+
         # check for self._conf.writable before going on?
         if not os.path.exists(self._mydir):
-            os.makedirs(self._mydir)
+            _makedirs_no_umask(self._mydir)
 
         attr = _sanitize(attr)
         if attr in self._read_cached_data:
@@ -1753,7 +1860,7 @@ class RPMDBAdditionalDataPackage(object):
         if attr.endswith('.tmp'):
             raise AttributeError, "%s has no attribute %s" % (self, attr)
 
-        info = misc.stat_f(fn)
+        info = misc.stat_f(fn, ignore_EACCES=True)
         if info is None:
             raise AttributeError, "%s has no attribute %s" % (self, attr)
 
diff --git a/yum/rpmtrans.py b/yum/rpmtrans.py
index 9b265f9..74a0f3f 100644
--- a/yum/rpmtrans.py
+++ b/yum/rpmtrans.py
@@ -119,7 +119,11 @@ class RPMBaseCallback:
         else:
             msg = '%s: %s' % (package, action)
         self.logger.info(msg)
-            
+
+    def verify_txmbr(self, base, txmbr, count):
+        " Callback for post transaction when we are in verifyTransaction(). "
+        pass
+
 
 class SimpleCliCallBack(RPMBaseCallback):
     def __init__(self):
@@ -140,6 +144,10 @@ class SimpleCliCallBack(RPMBaseCallback):
         if msgs:
             print msgs,
 
+    def verify_txmbr(self, base, txmbr, count):
+        " Callback for post transaction when we are in verifyTransaction(). "
+        print _("Verify: %u/%u: %s") % (count, len(base.tsInfo), txmbr)
+
 #  This is ugly, but atm. rpm can go insane and run the "cleanup" phase
 # without the "install" phase if it gets an exception in it's callback. The
 # following means that we don't really need to know/care about that in the
@@ -157,8 +165,12 @@ class _WrapNoExceptions:
         def newFunc(*args, **kwargs):
             try:
                 func(*args, **kwargs)
-            except:
-                pass
+            except Exception, e:
+                # It's impossible to debug stuff without this:
+                try:
+                    print "Error:", "display callback failed:", e
+                except:
+                    pass
 
         newFunc.__name__ = func.__name__
         newFunc.__doc__ = func.__doc__
@@ -463,6 +475,11 @@ class RPMTransaction:
         # SCRIPT_ERROR is only in rpm >= 4.6.0
         elif hasattr(rpm, "RPMCALLBACK_SCRIPT_ERROR") and what == rpm.RPMCALLBACK_SCRIPT_ERROR:
             self._scriptError(bytes, total, h)
+        # SCRIPT_START and SCRIPT_STOP are only in rpm >= 4.10
+        elif hasattr(rpm, "RPMCALLBACK_SCRIPT_START") and what == rpm.RPMCALLBACK_SCRIPT_START:
+            self._scriptStart(bytes, total, h);
+        elif hasattr(rpm, "RPMCALLBACK_SCRIPT_STOP") and what == rpm.RPMCALLBACK_SCRIPT_STOP:
+            self._scriptStop(bytes, total, h);
     
     
     def _transStart(self, bytes, total, h):
@@ -619,5 +636,19 @@ class RPMTransaction:
             msg = ("Non-fatal %s scriptlet failure in rpm package %s" % 
                    (scriptlet_name, package_name))
         self.display.errorlog(msg)
+        self._scriptout(package_name)
         # FIXME - what else should we do here? raise a failure and abort?
     
+    def _scriptStart(self, bytes, total, h):
+        pass
+
+    def _scriptStop(self, bytes, total, h):
+        name, txmbr = self._getTxmbr(h)
+        self._scriptout(txmbr or name)
+
+    def verify_txmbr(self, txmbr, count):
+        " Callback for post transaction when we are in verifyTransaction(). "
+        if not hasattr(self.display, 'verify_txmbr'):
+            return
+
+        self.display.verify_txmbr(self.base, txmbr, count)
